# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'access_key',
    'account_id',
    'assume_role',
    'client_connect_timeout',
    'client_read_timeout',
    'configuration_source',
    'ecs_role_name',
    'endpoints',
    'fc',
    'log_endpoint',
    'mns_endpoint',
    'ots_instance_name',
    'profile',
    'protocol',
    'region',
    'secret_key',
    'security_token',
    'security_transport',
    'shared_credentials_file',
    'skip_region_validation',
    'source_ip',
]

__config__ = pulumi.Config('alicloud')

access_key = __config__.get('accessKey')
"""
The access key for API operations. You can retrieve this from the 'Security Management' section of the Alibaba Cloud
console.
"""

account_id = __config__.get('accountId')
"""
The account ID for some service API operations. You can retrieve this from the 'Security Settings' section of the
Alibaba Cloud console.
"""

assume_role = __config__.get('assumeRole')

client_connect_timeout = __config__.get('clientConnectTimeout')
"""
The maximum timeout of the client connection server.
"""

client_read_timeout = __config__.get('clientReadTimeout')
"""
The maximum timeout of the client read request.
"""

configuration_source = __config__.get('configurationSource')
"""
Use this to mark a terraform configuration file source.
"""

ecs_role_name = __config__.get('ecsRoleName') or _utilities.get_env('ALICLOUD_ECS_ROLE_NAME')
"""
The RAM Role Name attached on a ECS instance for API operations. You can retrieve this from the 'Access Control' section
of the Alibaba Cloud console.
"""

endpoints = __config__.get('endpoints')

fc = __config__.get('fc')

log_endpoint = __config__.get('logEndpoint')

mns_endpoint = __config__.get('mnsEndpoint')

ots_instance_name = __config__.get('otsInstanceName')

profile = __config__.get('profile') or _utilities.get_env('ALICLOUD_PROFILE')
"""
The profile for API operations. If not set, the default profile created with `aliyun configure` will be used.
"""

protocol = __config__.get('protocol')

region = __config__.get('region') or _utilities.get_env('ALICLOUD_REGION')
"""
The region where Alibaba Cloud operations will take place. Examples are cn-beijing, cn-hangzhou, eu-central-1, etc.
"""

secret_key = __config__.get('secretKey')
"""
The secret key for API operations. You can retrieve this from the 'Security Management' section of the Alibaba Cloud
console.
"""

security_token = __config__.get('securityToken')
"""
security token. A security token is only required if you are using Security Token Service.
"""

security_transport = __config__.get('securityTransport')
"""
The security transport for the assume role invoking.
"""

shared_credentials_file = __config__.get('sharedCredentialsFile')
"""
The path to the shared credentials file. If not set this defaults to ~/.aliyun/config.json
"""

skip_region_validation = __config__.get('skipRegionValidation')
"""
Skip static validation of region ID. Used by users of alternative AlibabaCloud-like APIs or users w/ access to regions
that are not public (yet).
"""

source_ip = __config__.get('sourceIp')
"""
The source ip for the assume role invoking.
"""

